		/****************************************/
		/* ணࠬ    .		*/
		/* ᠭ .  䠩 kalah.doc	*/
		/* ⮨   ,		*/
		/*  -  䠩 kalah.c.		*/
		/*   ࡮   ஥.*/
		/****************************************/

#include <time.h>
#include <stdlib.h>
#include <stdio.h>	/* putchar	*/
#include <bios.h>	/* bioskey	*/

#include <xm.h>
#include <kbdcodes.h>
#include <kbd.h>

#include "kalah.h"

NODE rootPos, *root;
NODE  wStack[MAXLEVEL];
NODE  bestMove;
int   maxLevel=MAXLEVEL;
int   cL;

                /********************************/
		/* ⨯  㭪権.	*/
                /********************************/
float ABprune(PNODE p, float alpha, float beta);
PNODE first(PNODE p);   /*   ᫥ 樨 p  NULL,    */
                        /* ᫨ ⨣ ᨬ ஢.         */
void retPos(PNODE p);

PNODE next(PNODE p);    /* । 室  樨 p  NULL,         */
                        /* ᫨ ⨬ 室  .            */

int scatterStones(int desk[14], int move);
                        /*  室 move  樨 desk.            */

float estimate(PNODE p);/* ᫨ 業 樨.                    */
int isEmpty(PNODE p);   /* ᫨    ⨢ ,       */
                        /* ਬ ࠢ 1.4   1.           */
                        /*  ⨢ 砥  0.                */
void setLocs(void);     /* ⠭ "࠭" न .      */
void initialize(void);  /* 直 砫 ⠭.                  */


LOCAL float ABprune(PNODE p, float alpha, float beta)
/* Alpha-beta pruning (⮤ ࠭  業)   ..        */
/* 頥 業  樨 p.				*/
{
   float 	m, t;
   PNODE 	curPos;

   cL++;
   curPos = first(p);		/* ᫨  樨 p  뭮,	*/
				/* ୥ NULL.				*/
   if(curPos == NULL) {
      cL--;
      return estimate(p);	/*  室  楤,		*/
   }   				/*   ନ쭠.		*/
   else {
      m = alpha;
      while((curPos != NULL) && (m < beta)) {
         t = -ABprune(curPos, -beta, -m);
         if(t > m)
            m = t;
         curPos = next(p);
      }
   }
   cL--;
   return m; 			/*   - 室   ⠫   */
   				/* 権.				*/
}/*ABprune*/

ENTRY int findMove(PNODE p)
{
   PNODE 	pcurPos;
   NODE		curPos;
   int		res=0;
   float 	t,m;

   cL=0;                        /* ⮡ ᯮ짮 first!         */
   pcurPos = first(p);          /* 㥬 ࢮ 뭠 p.          */

   if(pcurPos == NULL) {
      return 0;			/*  室  楤,		*/
   }   				/*   ନ쭠.		*/
   else {
      m = -200;
      while(pcurPos != NULL) {
         cL = -1;               /* "।ࢮ" ﭨ ஢.       */
         curPos = wStack[0];    /* 쬥   ⥪.            */
         t = -ABprune(&curPos, -200, 200);
         if((t > m) || (t == m && random(2))) {
            m = t;
            bestMove = curPos;
            res++;
         }
         wStack[0] = curPos; cL = 0;    /*    ⥪      */
         pcurPos = next(p);             /* ᣥ㥬 ᫥.       */
      }
   }
   return res;
}/*findMove*/

LOCAL PNODE first(PNODE p)
{
   if(cL < maxLevel) {
      wStack[cL].extent = 0;
      wStack[cL].move[0] = Aplays(*p) ? -1 : 6;
      return next(p);
   }
   return NULL;
}/*first*/

LOCAL void retPos(PNODE p)
{
   int i;

                      /* 砫 ᪮㥬   p         */
   memmove(wStack[cL].desk,p->desk,sizeof(p->desk));
                      /*  த ஢ 室    */
                      /*  樨, ।饩 ⥪饩.    */
   for(i=0;i<wStack[cL].extent;i++) {
      scatterStones(wStack[cL].desk,wStack[cL].move[i]);
      if (isEmpty(&wStack[cL])) break;
   }
}/*retPos*/

LOCAL PNODE next(PNODE p)
{
   int U = Aplays(*p) ? 6 : 13;
   int move,t;
		/****  । 室.	****/
   retPos(p); /* ந   । 室.     */
                         /*  ⨬ 室.         */
   move = wStack[cL].move[wStack[cL].extent];
   while(++move < U && wStack[cL].desk[move] == 0);
   wStack[cL].move[wStack[cL].extent] = move;

   if(move == U)
      return (wStack[cL].extent-- == 0) ? NULL : next(p);
   else {		/* move < U	*/
      t = scatterStones(wStack[cL].desk,move);
      if(t) {
         if(isEmpty(&wStack[cL]))
            return &wStack[cL];
         else { /* 1.2. (!) */
            wStack[cL].move[++wStack[cL].extent] =
         			Aplays(*p) ? -1 : 6;
            return next(p);
         }
      }
      else
         return &wStack[cL];
   }
}/*next*/

#define INC(i)          i++;                                    \
      if (move < 6 /*  ப A */ &&                        \
          i == 13  /* ࠥ    ப B */     \
          ||                                                    \
          move > 6 /*  ப B */ &&                        \
          i == 14  /* 諨   ᨢ */) i = 0;         \
      else                                                      \
      if (move > 6 /*  ப B */ &&                        \
          i == 6   /* ய⨬  ப A */) i++;

LOCAL int scatterStones(int desk[14], int move)
{
   int i, fin=0, stones;

   i = move;
   stones = desk[i];            /* ⢮ ।塞      */
   desk[i] = 0;
   while(stones--) {                            /*  誨:    */
      INC(i);                            /* 稬 i                 */
      desk[i]++;                         /*  । 襪.  */
   }
                             /*** ࠢ 1.3: ***/
                             /*  稫   ⮬ .    */
   if(desk[i] == 1 && desk[12-i] > 0 &&      /*  ⨢ . */
      ((move < 6 &&                          /*  ப A            */
         i < 6) ||                           /*  稫   .  */
       (move > 6 &&                          /*  ப B            */
        i > 6 && i < 13))) {                 /*  稫   .  */
      desk[move<6? 6:13] += desk[i] + desk[12-i];
      desk[i] = desk[12-i] = 0;
   }
		/*** 騬  ⮬,  㦭 ਬ ࠢ 1.2. ***/
   if (move < 6 && i == 6 || move > 6 && i == 13) fin = 1;
   return fin;
}/*scatterStones*/

#undef INC

LOCAL float estimate(PNODE p)
/* ᫨ 業 樨.			*/
{
    float value;
    value  = p->desk[6] - p->desk[13];
/*    value += 17.3/(37.5 - p->desk[6]) -
                        17.3/(37.5 - p->desk[13]) + 1.72;*/
    if(!Aplays(*p))
       value = -value;
    return value;
}/*estimate*/

LOCAL int isEmpty(PNODE p)
{
   int i,fin;
                                /*** ࠢ 1.4. ***/
   fin = 1;
   for(i=0;i<6;i++) if(p->desk[i]) fin = 0;
   if(fin) {
      for(i=7;i<13;i++) {
         p->desk[13] += p->desk[i]; p->desk[i] = 0;
      }
      return 1;
   }
   fin = 1;
   for(i=7;i<13;i++) if(p->desk[i]) fin = 0;
   if(fin)
      for(i=0;i<6;i++) {
         p->desk[6] += p->desk[i]; p->desk[i] = 0;
      }
   return fin;
}/*isEmpty*/

/**********************************************************************/
/*                                                */
/**********************************************************************/

#include <conio.h>	/* gotoxy	*/

ENTRY int getMove(void)
{
   int ch, move;

   while(1) {			/*    짮⥫	*/
      gotoxy(1,1);
      printf(" 室:         "); gotoxy(12,1);
      if((ch = bioskey(0)) == KBD_NORMAL(ESC))       /*     	*/
	 exit(-1);         	/*  <ESC> - 뢠  	*/
      putchar(ch);
      move = kbd_ascii(ch) - '0';		/* 㥬 ⨥     */
      if (move < 0 || move > 5 || root->desk[move] == 0 ) {
         putchar('\a');			/*    - "㤭" 	*/
         continue;			/*  ᫥饣 	*/
      }
      break;				/*  - 室  横	*/
   }
   return move;
}/*getMove*/

/**************************************************************************/
/*                                     */
/**************************************************************************/

int x[14],y[14];	/* न   ࠭.	*/

LOCAL void setLocs(void)
{
   int i;

   for (i=0; i < 6; i++) {		/* । न	*/
      y[i] = 20;            y[i+7] = 15;
      x[i] = 8+9*(i+1);     x[i+7] = 71-9*(i+1);
   }
   x[6] = 7+9*7; x[13] = 71-9*7;
   y[6] = 18;    y[13] = 18;
}/*setLocs*/

ENTRY void drawScreen(void)
{
   int i;

   for(i=0;i<14;i++) {
      gotoxy (x[i],y[i]);
      printf ("%2d",root->desk[i]);
   }
}/*drawScreen*/

LOCAL void initialize(void)
{
   int i;

   randomize();
   clrscr();
   root = &rootPos;
   for(i=0; i < 6;i++)
      root->desk[i] = root->desk[i+7] = 6;
   root->desk[6] = root->desk[13] = 0;

   setLocs();
   for(i=6;i<=72;i++) {
      gotoxy(i,14) ; printf("-");
      gotoxy(i,21); printf("-");
   }
   for(i=1;i<=6;i++) {
      gotoxy(9*i+9,22); printf("%d",i-1);
      gotoxy(9*i+9,13); printf("%d",13-i);
   }
   drawScreen();
}/*initialize*/

NODE gameA[100];
NODE gameB[100];
int gameLength=0;

void main(void)
{
   int i,k,done=0;
   FILE	*file;

   initialize();
                /*  ⮩ ᨨ  室  ணࠬ,           */
                /* ⮬ ந "।ࢮ" ﭨ:             */
                /* ⢮ਬ,   室 㦥 ᤥ - ப B.  */
   rootPos.extent = 0; rootPos.move[0] = 13;
   while(!done) {

      for(k=0;k!=-1;) {
         rootPos.move[k] = getMove();
         gameA[gameLength].extent = k+1;
         gameA[gameLength].move[k] = rootPos.move[k];
         if(scatterStones(rootPos.desk, rootPos.move[k])) k++;
         else k = -1;
         drawScreen();
         if(isEmpty(root)) {
            done = 1;
            break;
         }
      }
      if(!done) {

         if(!findMove(root)) {
            drawScreen();
            break;
         }
         gameB[gameLength].extent = bestMove.extent+1;
         for(k=0;k<=bestMove.extent;k++) {
            gameB[gameLength].move[k] = bestMove.move[k];
            gotoxy(1,1); clreol();
            printf("   ");
            for(i=k;i<=bestMove.extent;i++)
               printf(" %2d",bestMove.move[i]);
            bioskey(0);
            scatterStones(rootPos.desk,bestMove.move[k]);
            drawScreen();
            if(isEmpty(root)) {
               done = 1;
               break;
            }
         }

         gameLength++;
      }
   }
   drawScreen();

   file = fopen("lastGame.klh","wt");
   gotoxy(1,1);
   for(i=0; i<gameLength; i++) {
      printf("\n%3d) A:",i+1);
      fprintf(file,"\n%2d) A:",i+1);
      for(k=0; k<gameA[i].extent;k++) {
         printf(" %2d",gameA[i].move[k]);
         fprintf(file," %2d",gameA[i].move[k]);
      }
      printf("\t\tB:");
      fprintf(file,"\t\tB:");
      for(k=0; k<gameB[i].extent;k++) {
         printf(" %2d",gameB[i].move[k]);
         fprintf(file," %2d",gameB[i].move[k]);
      }
   }
   fprintf(file,"\n\n  砭 :\n"
   	        "\t   - %d\n"
   	        "\t  B - %d\n",
                rootPos.desk[6],rootPos.desk[13]);
   fclose(file);
}/*main*/

